//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "DM.h"
#include "ExecForm.h"
#include "GridOpt.h"
#include "TblOpt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TrElmnts"
#pragma link "TrReport"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GroupBand1GetGroupValue(TTrGroupBand *Sender,
      Variant &Value)
{
        Value = DataModule1->CustomerCompany->AsString.SubString(1, 1);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Cell122Print(TTrCustomCell *Sender)
{
        Sender->Caption = DataModule1->CustomerCompany->AsString.SubString(1, 1);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OnExecuteEventReportExecute(
      TTrCustomReport *Sender)
{
        ExecuteForm->Report = OnExecuteEventReport;
        ExecuteForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::MemoPrint(TObject *Sender)
{
  Memo->Transform("Date", DateToStr(Date()));
  Memo->Transform("FirstName", DataModule1->EmployeeFirstName->AsString);
  Memo->Transform("LastName", DataModule1->EmployeeLastName->AsString);
  Memo->Transform("Hiredate", DataModule1->EmployeeHireDate->AsString);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::RuntimeReportBeforePrint(TTrCustomReport *Sender)
{
    RuntimeReportPage1->Bands->HasTitle = True;
    RuntimeReportPage1->TitleBand->Height = 600;
    for (int i = 0; i < 10; i++)
    {
      TTrLabel * Label = new TTrLabel(MainForm);
      Label->Parent = RuntimeReportPage1->TitleBand;
      Label->Top = i * 40;
      Label->Left = i * 40;
      Label->Font->Size = 14;
      Label->Caption = "Welcome to TableReport";
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OnNeedDataReportPage1BeforePrint(
      TTrCustomPage *Sender, bool &PrintPage)
{
  FNumber = 1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DetailBand12BeforePrint(TTrCustomBand *Sender,
      bool &PrintBand)
{
  Label3->Caption = IntToStr(FNumber);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DetailBand12AfterPrint(TTrCustomBand *Sender,
      bool BandPrinted)
{
  FNumber++;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DetailBand12NeedData(TTrDetailBand *Sender,
      bool &MoreData)
{
  MoreData = FNumber < 10000;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CrossTabEventsReportPage1CrossTabDefineColumn(
      TTrCustomPage *APage, TTrCrossTab *ACrossTab, Variant &ColumnValue,
      AnsiString &ColumnTitle)
{
        Word Year, Month, Day;
        DecodeDate(DataModule1->CrossTabQuerySaleDate->AsDateTime, Year, Month, Day);
        ColumnValue = Month + Year * 12;
        ColumnTitle = LongMonthNames[Month];
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CrossTabEventsReportPage1CrossTabDefineColumnGroup(
      TTrCustomPage *APage, TTrCrossTab *ACrossTab,
      TTrCustomCell *AGroupCell, Variant &AGroupValue,
      AnsiString &GroupTitle, bool &AEnableGroupTotal,
      AnsiString &AGroupTotalTitle)
{
        Word Year, Month, Day;
        DecodeDate(DataModule1->CrossTabQuerySaleDate->AsDateTime, Year, Month, Day);
        if (AGroupCell == Cell253)
        {
          AGroupValue = int(Year);
          AEnableGroupTotal = True;
          AGroupTotalTitle = "Year Total";
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::RuntimeExternalPagesReportChangeExternalPages(
      TTrCustomReport *Sender)
{
        Sender->ExternalPages->Clear();
        Sender->ExternalPages->AddPage(CrossTabReportPage1);
        Sender->ExternalPages->AddPage(DetailReportPage1);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GroupBand2GetGroupValue(TTrGroupBand *Sender,
      Variant &Value)
{
        Value = DataModule1->CrossTabQueryCompany->AsString.SubString(1, 1);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Cell250Print(TTrCustomCell *Sender)
{
        Sender->Caption = DataModule1->CrossTabQueryCompany->AsString.SubString(1, 1);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Cell251Print(TTrCustomCell *Sender)
{
        if ((Sender->CrossTabColumn->Kind == ckTotal) || (Sender->CrossTabColumn->Kind == ckGroupTotal))
                Sender->Font->Style = TFontStyles() << fsItalic;
        else
        {
              if (Sender->CrossTabValue > 20000)
                Sender->Font->Color = clRed;
              else
                Sender->Font->Color = clBlack;
        }
}
//---------------------------------------------------------------------------

typedef TTrModuleReport* PModuleReport;

void __fastcall TMainForm::TreeView1Change(TObject *Sender, TTreeNode *Node)
{
  if (TreeView1->Selected != NULL)
    Memo1->Lines = PModuleReport(TreeView1->Selected->Data)->Description;

}
//---------------------------------------------------------------------------



void __fastcall TMainForm::GridFormattingReportExecute(
      TTrCustomReport *Sender)
{
  GridOptionsForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GridFormattingReportPage1BeforePrint(
      TTrCustomPage *Sender, bool &PrintPage)
{
   switch (GridOptionsForm->RadioGroup1->ItemIndex)
   {
    case 1:
      Grid3->SelectCells(Cell266, Cell303);
      Grid3->SetSelectionVisible(False);
      Grid3->SelectCells(Cell254, Cell309);
      Grid3->SetSelectionVisible(False);
      break;
    case 2:
      Grid3->SelectCells(Cell304, Cell310);
      Grid3->SetSelectionVisible(False);
      Grid3->SelectCells(Cell268, Cell310);
      Grid3->SetSelectionVisible(False);
      break;
  }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::HidingTableColumnsReportPage1BeforePrint(
      TTrCustomPage *Sender, bool &PrintPage)
{
  Integer CurWidth;
  TTrCustomCell* Cell;
  CurWidth = HidingTableColumnsReportPage1->Table->Width;

  if (!ReportOptionsForm->AdressCheckBox->Checked)
  {
    HidingTableColumnsReportPage1->Table->SelectCells(Cell104, Cell284);
    HidingTableColumnsReportPage1->Table->SetSelectionVisible(False);
  };
  if (!ReportOptionsForm->PhoneCheckBox->Checked)
  {
    HidingTableColumnsReportPage1->Table->SelectCells(Cell276, Cell292);
    HidingTableColumnsReportPage1->Table->SetSelectionVisible(False);
  };
  if (!ReportOptionsForm->TaxRateCheckBox->Checked)
  {
    HidingTableColumnsReportPage1->Table->SelectCells(Cell278, Cell293);
    HidingTableColumnsReportPage1->Table->SetSelectionVisible(False);
  };
  if (!ReportOptionsForm->ContactCheckBox->Checked)
  {
    HidingTableColumnsReportPage1->Table->SelectCells(Cell279, Cell294);
    HidingTableColumnsReportPage1->Table->SetSelectionVisible(False);
  };
  if (!ReportOptionsForm->MergeCheckBox->Checked)
  {
    HidingTableColumnsReportPage1->Table->SelectCells(Cell101, Cell102);
    HidingTableColumnsReportPage1->Table->MergeCells()->Caption = "CustNo and Company";
  };
  if (ReportOptionsForm->StretchCheckBox->Checked)
    HidingTableColumnsReportPage1->Table->Width = CurWidth;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::HidingTableColumnsReportExecute(
      TTrCustomReport *Sender)
{
  ReportOptionsForm->ShowModal();
}
//---------------------------------------------------------------------------

